#pragma once
#include <exception>
#include <string>

class FileException: public std::exception {
private:
	std::string error;
public:
	FileException(int code) {
		switch (code) {
			case 1: error.assign("Error: File has not opened!"); break;
			case 2: error.assign("Error: File renaming has not successfully completed!"); break;
		}
	}

	const char* what() const noexcept override {
		return error.c_str();
	}
};